/*
 * Copyright 2024 Cendio AB.
 * For more information, see http://www.cendio.com
 */

window.addEventListener("load", textareaHandlers);

function textareaHandlers() {
    // Create an array of all elements with 'multiline' class
    let textareas = [].slice.call(document.getElementsByClassName("multiline"));
    if (textareas.length == 0) {
        return;
    }
    // Remove elements that aren't textareas
    textareas.filter((elem) => (elem.tagName != "TEXTAREA"));

    textareas.forEach((textarea) => textarea.addEventListener(
        "input", convertSpacesToNewlines
    ));

    // Remove trailing newlines
    textareas.forEach((textarea) => {
        textarea.value = textarea.value.replace(/\n$/, "");
    });
}

function convertSpacesToNewlines(event) {
    let selectionEnd = event.target.selectionEnd;
    event.target.value = event.target.value.replace(/\s/g, "\n");
    event.target.selectionEnd = selectionEnd; // Restore cursor position

    // Set number of rows to the number of lines
    event.target.rows = event.target.value.split("\n").length;
}
